// JavaScript Document

var stage;
var rectX;
var rectY;
var thisBox;
var boxesLayer;
var box = new Array();
var cuadrado;

function doSend(message){
	websocket.send(message);	
}

function new_box(rectX, rectY, color){
	var aux = new Kinetic.Rect({
		x: rectX,
		y: rectY,
		width: window.innerWidth/10,
		height: window.innerHeight/10,
		fill: color,
		stroke: "black",
		strokeWidth: 0,
		draggable: false
	});
	box.push(aux);
	boxesLayer.add(aux);
	thisBox.moveToTop();
	boxesLayer.draw();
}

function redraw(posx, posy, color){
	for(cuadrado in box){
		if(box[cuadrado].getFill() == color){
			box[cuadrado].setX(posx);
			box[cuadrado].setY(posy);
			thisBox.moveToTop();
			boxesLayer.draw();

		}
	}
}

function delete_box(color){
	for(cuadrado in box){
		if(box[cuadrado].getFill() == color){
			boxesLayer.remove(box[cuadrado]);
			thisBox.moveToTop();
			boxesLayer.draw();

		}
	}
}


function browser(thisBox,stage){
	var is_touch_device = 'ontouchstart' in document.documentElement;
	
//	if(window.innerHeight <= 600 || window.innerWidth < 800){
	if(is_touch_device){
		thisBox.on('dragmove', function(){
		var touchPos = stage.getTouchPosition();
		var x = touchPos.x;
		var y = touchPos.y;
		doSend(x + " " + y);
	});
	}else{
		thisBox.on('dragmove', function(){
		var mousePos = stage.getMousePosition();
		var x = mousePos.x;
		var y = mousePos.y;
		doSend(x + " " + y);
		});
	}
}

function check_socket(received){
		var n, color, posx, posy;
		n = received.data.split(" ");
		if(n[0] == "init"){
			color = n[1];
			thisBox = new Kinetic.Rect({
				x: rectX,
				y: rectY,
				width: window.innerWidth/10,
				height: window.innerHeight/10,
				fill: color,
				stroke: "black",
				strokeWidth: 0,
				draggable: true
			});
			boxesLayer.add(thisBox);
			stage.add(boxesLayer);
			browser(thisBox,stage);
			thisBox.moveToTop();
			boxesLayer.draw();

		}
		if(n[0] == "pos"){
			posx = n[1];
			posy = n[2];
			color = n[3];
			redraw(posx,posy,color);	
		}
		if(n[0] == "create"){
			color = n[1];
			new_box(rectX,rectY,color);
		}
		if(n[0] == "del"){
			color = n[1];
			delete_box(color);	
		}
	}


window.onload = function() {
	
	stage = new Kinetic.Stage({
	container: "container",
	width: window.innerWidth,
	height: window.innerHeight
	});
	rectX = stage.getWidth() / 2 - 50;
	rectY = stage.getHeight() / 2 - 25;
	
	boxesLayer = new Kinetic.Layer();

	var wsUri = "ws://kiroh.dyndns.org/ws"; 
	websocket = new WebSocket(wsUri); 
	websocket.onopen;
	
	websocket.onmessage = check_socket;
};
